#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define LETTER_CNT ('z'-'a'+1)
#define MALA 0
#define VELKA 1

char *nactiRadek()
{
    char *radek = calloc(256,sizeof(char));
    fgets(radek,255,stdin);
    char *nl = strchr(radek,'\n');
    int konec = nl != NULL;

    if(konec)
    {
        *nl=0;
    }

    while(!konec)
    {
        char c = getchar();
        konec = c == '\n';
        if(!konec)
        {
            realloc(radek,strlen(radek)+2);
            strncat(radek,&c,1);
        }
    }
    return radek;
}
char *nactiVstup()
{
    char *vstup = NULL;
    char *radek = nactiRadek();
    while(strlen(radek))
    {
        if(vstup)
        {
            realloc(vstup,strlen(vstup)+strlen(radek)+1);
            strcat(vstup,radek);

        }
        else
        {
            vstup = calloc(strlen(radek)+1,sizeof(char));
            strcpy(vstup,radek);

        }
        free(radek);
        radek = nactiRadek();
    }
    return vstup;
}

void spocitejCetnosti(char* vstup,double cetnosti[][LETTER_CNT])
{
    int strlength = strlen(vstup);

    for(int i=0;i<2;i++)
    {
        for(int j=0;j<LETTER_CNT;j++)
            cetnosti[i][j]=0.0;
    }

    for(int i = 0; i < strlength; i++)
    {
        if(islower(vstup[i]))
        {
            cetnosti[MALA][vstup[i]-'a']++;
        }
        else if(isupper(vstup[i]))
        {
            cetnosti[VELKA][vstup[i]-'A']++;
        }
    }
    for(int i=0;i<2;i++)
    {
        for(int j=0;j<LETTER_CNT;j++)
        {
            cetnosti[i][j]/=strlen(vstup);
        }
    }
}

void vytvorHistogram(double cetnosti[][LETTER_CNT],char histogram[][LETTER_CNT*2])
{
    for(int i=0;i<25;i++)
    {
        for(int j=0;j<LETTER_CNT*2;j++)
            histogram[i][j]=' ';
    }
    for(int i=0;i<2;i++)
    {
        for(int j=0;j<LETTER_CNT;j++)
        {
            if(i)
                histogram[24][j+LETTER_CNT]=  'A'  + j;
            else
                histogram[24][j]=  'a'  + j;
            int k = 23;
            for(double cetnost = cetnosti[i][j];cetnost>0;cetnost -= 0.05)
            {
                if(i)
                    histogram[k][j+LETTER_CNT]='o';
                else
                    histogram[k][j]='o';
                k--;
            }
        }
    }
}

void vykresliHistogram(char histogram[][LETTER_CNT*2])
{
    for(int i=0;i<25;i++)
    {
        for(int j=0;j<LETTER_CNT*2;j++)
         putchar(histogram[i][j]);
        printf("\n");
    }
}

int main()
{
    char histogram[25][LETTER_CNT*2];
    double cetnosti[2][LETTER_CNT];
    char *vstup;

    vstup = nactiVstup();
    spocitejCetnosti(vstup,cetnosti);
    vytvorHistogram(cetnosti,histogram);
    vykresliHistogram(histogram);

    free(vstup);

    return 0;
}
